//
//  HashCreator.m
//  PayUMoney Demo
//
//  Created by Akash Patel on 13/02/20.
//  Copyright © 2020 Akash Patel. All rights reserved.
//

#import "HashCreator.h"
#import <CommonCrypto/CommonDigest.h>
#import <PlugNPlay/PlugNPlay.h>

@implementation HashCreator

+ (NSString*) createSHA512:(NSString *)source {
    
    const char *cstr = [source cStringUsingEncoding:NSUTF8StringEncoding];
    NSData *data = [NSData dataWithBytes:cstr length:source.length];
    uint8_t digest[CC_SHA512_DIGEST_LENGTH];
    CC_SHA512(data.bytes, (CC_LONG)data.length, digest);
    NSMutableString* output = [NSMutableString  stringWithCapacity:CC_SHA512_DIGEST_LENGTH * 2];

    for(int i = 0; i < CC_SHA512_DIGEST_LENGTH; i++)
        [output appendFormat:@"%02x", digest[i]];
    
    NSString *hash =  [[[output stringByReplacingOccurrencesOfString:@"<" withString:@""]stringByReplacingOccurrencesOfString:@">" withString:@""]stringByReplacingOccurrencesOfString:@" " withString:@""];

    return hash;
}

@end
