import 'dart:async';

import 'package:flutter/services.dart';

class FlutterPayumoneyPlugin {
  static const MethodChannel _channel =
      const MethodChannel('flutter_payumoney_plugin');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> payUMoneyPayment({int environmentMode,String email,String amount,
      String mobile,String formName, String UserName}) async
  {
    final String paymentID = await _channel.invokeMethod('payUmoneyPayment',
      {
        "environmentMode":environmentMode, // SANDBOX & LIVE MODE
        "email":email,
        "amount":amount,
        "mobile":mobile,
        "formName":formName,
        "UserName":UserName,
      }
    );
    return paymentID;
  }


}
